Index: sys/kern/sys_procdesc.c
===================================================================
--- sys/kern/sys_procdesc.c	(.../stable/8)	(revision 0)
+++ sys/kern/sys_procdesc.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,483 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*-
+ * FreeBSD process descriptor facility.
+ *
+ * Some processes are represented by a file descriptor, which will be used in
+ * preference to signaling and pids for the purposes of process management,
+ * and is, in effect, a form of capability.  When a process descriptor is
+ * used with a process, it ceases to be visible to certain traditional UNIX
+ * process facilities, such as waitpid(2).
+ *
+ * Some semantics:
+ *
+ * - At most one process descriptor will exist for any process, although
+ *   references to that descriptor may be held from many processes (or even
+ *   be in flight between processes over a local domain socket).
+ * - Last close on the process descriptor will terminate the process using
+ *   SIGKILL and reparent it to init so that there's a process to reap it
+ *   when it's done exiting.
+ * - If the process exits before the descriptor is closed, it will not
+ *   generate SIGCHLD on termination, or be picked up by waitpid().
+ * - The pdkill(2) system call may be used to deliver a signal to the process
+ *   using its process descriptor.
+ * - The pdwait(2) system call may be used to block (or not) on a process 
+ *   descriptor to collect termination information.
+ *
+ * Open questions:
+ *
+ * - How to handle ptrace(2)?
+ * - Will we want to add a pidtoprocdesc(2) system call to allow process
+ *   descriptors to be created for processes without pfork(2)?
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$P4");
+
+#include "opt_procdesc.h"
+
+#include <sys/param.h>
+#include <sys/capability.h>
+#include <sys/fcntl.h>
+#include <sys/file.h>
+#include <sys/filedesc.h>
+#include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/poll.h>
+#include <sys/proc.h>
+#include <sys/procdesc.h>
+#include <sys/stat.h>
+#include <sys/sysproto.h>
+#include <sys/sysctl.h>
+#include <sys/systm.h>
+#include <sys/ucred.h>
+
+#include <security/audit/audit.h>
+
+#include <vm/uma.h>
+
+#ifdef PROCDESC
+
+static uma_zone_t procdesc_zone;
+
+static fo_rdwr_t	procdesc_read;
+static fo_rdwr_t	procdesc_write;
+static fo_truncate_t	procdesc_truncate;
+static fo_ioctl_t	procdesc_ioctl;
+static fo_poll_t	procdesc_poll;
+static fo_kqfilter_t	procdesc_kqfilter;
+static fo_stat_t	procdesc_stat;
+static fo_close_t	procdesc_close;
+
+static struct fileops procdesc_ops = {
+	.fo_read = procdesc_read,
+	.fo_write = procdesc_write,
+	.fo_truncate = procdesc_truncate,
+	.fo_ioctl = procdesc_ioctl,
+	.fo_poll = procdesc_poll,
+	.fo_kqfilter = procdesc_kqfilter,
+	.fo_stat = procdesc_stat,
+	.fo_close = procdesc_close,
+	.fo_flags = DFLAG_PASSABLE,
+};
+
+/*
+ * We don't currently have any MIB entries for sysctls, but we do expose
+ * kern.procdesc so that it's easy to tell if options PROCDESC is compiled
+ * into the kernel.
+ */
+SYSCTL_NODE(_kern, OID_AUTO, procdesc, CTLFLAG_RW, 0,
+    "TrustedBSD process descriptor controls");
+
+/*
+ * Initialize with VFS so that process descriptors are available along with
+ * other file descriptor types.  As long as it runs before init(8) starts,
+ * there shouldn't be a problem.
+ */
+static void
+procdesc_init(void *dummy __unused)
+{
+ 
+	procdesc_zone = uma_zcreate("procdesc", sizeof(struct procdesc),
+	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
+	if (procdesc_zone == NULL)
+		panic("procdesc_init: procdesc_zone not initialized");
+}
+SYSINIT(vfs, SI_SUB_VFS, SI_ORDER_ANY, procdesc_init, NULL);
+
+/*
+ * Return a locked process given a process descriptor, or ESRCH if it has
+ * died.
+ */
+int
+procdesc_find(struct thread *td, int fd, cap_rights_t rights,
+    struct proc **p)
+{
+	struct procdesc *pd;
+	struct file *fp;
+	int error;
+
+	error = fget(td, fd, rights, &fp);
+	if (error)
+		return (error);
+	if (fp->f_type != DTYPE_PROCDESC) {
+		error = EBADF;
+		goto out;
+	}
+	pd = fp->f_data;
+	sx_slock(&proctree_lock);
+	if (td->td_proc != NULL) {
+		*p = pd->pd_proc;
+		PROC_LOCK(*p);
+	} else
+		error = ESRCH;
+	sx_sunlock(&proctree_lock);
+out:
+	fdrop(fp, td);
+	return (error);
+}
+
+/*
+ * Function to be used by procstat(1) sysctls when returning procdesc
+ * information.
+ */
+pid_t
+procdesc_pid(struct file *fp_procdesc)
+{
+	struct procdesc *pd;
+
+	KASSERT(fp_procdesc->f_type == DTYPE_PROCDESC,
+	   ("procdesc_pid: !procdesc"));
+
+	pd = fp_procdesc->f_data;
+	return (pd->pd_pid);
+}
+
+/*
+ * System call to return the pid of a process given its process descriptor.
+ */
+int
+pdgetpid(struct thread *td, struct pdgetpid_args *uap)
+{
+	struct procdesc *pd;
+	struct file *fp;
+	pid_t pid;
+	int error;
+
+	AUDIT_ARG_FD(uap->fd);
+	error = fget(td, uap->fd, CAP_PDGETPID, &fp);
+	if (error)
+		return (error);
+	if (fp->f_type == DTYPE_PROCDESC) {
+		pd = fp->f_data;
+		pid = pd->pd_pid;
+		AUDIT_ARG_PID(pid);
+	} else
+		error = EBADF;
+	fdrop(fp, td);
+	if (error == 0)
+		error = copyout(&pid, uap->pidp, sizeof(pid));
+	return (error);
+}
+
+/*
+ * When a new process is forked by pdfork(), a file descriptor is allocated 
+ * by the fork code first, then the process is forked, and then we get a
+ * chance to set up the process descriptor.  Failure is not permitted at this
+ * point, so procdesc_new() must succeed.
+ */
+void
+procdesc_new(struct proc *p, struct file *fp_procdesc)
+{
+	struct procdesc *pd;
+
+	pd = uma_zalloc(procdesc_zone, M_WAITOK | M_ZERO);
+	pd->pd_proc = p;
+	pd->pd_pid = p->p_pid;
+	p->p_procdesc = pd;
+	PROCDESC_LOCK_INIT(pd);
+
+	/*
+	 * Process descriptors start out with two references: one from their
+	 * struct file, and the other from their struct proc.
+	 */
+	refcount_init(&pd->pd_refcount, 2);
+
+	/* XXXRW: Why these flags? */
+	finit(fp_procdesc, FREAD | FWRITE, DTYPE_PROCDESC, pd,
+	    &procdesc_ops);
+}
+
+static void
+procdesc_free(struct procdesc *pd)
+{
+
+	/*
+	 * When the last reference is released, we assert that the descriptor
+	 * has been closed, but not that the process has exited, as we will
+	 * detach the descriptor before the process dies if the descript is
+	 * closed, as we can't wait synchronously.
+	 */
+	if (refcount_release(&pd->pd_refcount)) {
+		KASSERT(pd->pd_proc == NULL,
+		    ("procdesc_free: pd_proc != NULL"));
+		KASSERT((pd->pd_flags & PD_CLOSED),
+		    ("procdesc_free: !PD_CLOSED"));
+
+		PROCDESC_LOCK_DESTROY(pd);
+		uma_zfree(procdesc_zone, pd);
+	}
+}
+
+/*
+ * procdesc_exit() - notify a process descriptor that its process is exiting. 
+ * We use the proctree_lock to ensure that process exit either happens
+ * strictly before or strictly after a concurrent call to procdesc_close().
+ */
+int
+procdesc_exit(struct proc *p)
+{
+	struct procdesc *pd;
+
+	sx_assert(&proctree_lock, SA_XLOCKED);
+	PROC_LOCK_ASSERT(p, MA_OWNED);
+	KASSERT(p->p_procdesc != NULL, ("procdesc_exit: p_procdesc NULL"));
+
+	pd = p->p_procdesc;
+
+	PROCDESC_LOCK(pd);
+	KASSERT((pd->pd_flags & PD_CLOSED) == 0 || p->p_pptr == initproc,
+	    ("procdesc_exit: closed && parent not init"));
+
+	pd->pd_flags |= PD_EXITED;
+
+	/*
+	 * If the process descriptor has been closed, then we have nothing
+	 * to do; return 1 so that init will get SIGCHLD and do the reaping.
+	 * Clean up the procdesc now rather than letting it happen during
+	 * that reap.
+	 */
+	if (pd->pd_flags & PD_CLOSED) {
+		PROCDESC_UNLOCK(pd);
+		pd->pd_proc = NULL;
+		p->p_procdesc = NULL;
+		procdesc_free(pd);
+		return (1);
+	}
+	if (pd->pd_flags & PD_SELECTED) {
+		pd->pd_flags &= ~PD_SELECTED;
+		selwakeup(&pd->pd_selinfo);
+	}
+	PROCDESC_UNLOCK(pd);
+	return (0);
+}
+
+/*
+ * When a process descriptor is reaped, perhaps as a result of close() or
+ * pdwait4(), release the process's reference on the process descriptor.
+ */
+void
+procdesc_reap(struct proc *p)
+{
+	struct procdesc *pd;
+
+	sx_assert(&proctree_lock, SA_XLOCKED);
+	KASSERT(p->p_procdesc != NULL, ("procdesc_reap: p_procdesc == NULL"));
+
+	pd = p->p_procdesc;
+	pd->pd_proc = NULL;
+	procdesc_free(pd);
+}
+
+/*
+ * procdesc_close() - last close on a process descriptor.  If the process is
+ * still running, terminate with SIGKILL and let init(8) clean up the mess;
+ * if not, we have to clean up the zombie ourselves.
+ */
+static int
+procdesc_close(struct file *fp, struct thread *td)
+{
+	struct procdesc *pd;
+	struct proc *p;
+
+	KASSERT(fp->f_type == DTYPE_PROCDESC, ("procdesc_close: !procdesc"));
+
+	pd = fp->f_data;
+	fp->f_ops = &badfileops;
+	fp->f_data = NULL;
+
+	sx_xlock(&proctree_lock);
+	PROCDESC_LOCK(pd);
+	pd->pd_flags |= PD_CLOSED;
+	PROCDESC_UNLOCK(pd);
+	p = pd->pd_proc;
+	PROC_LOCK(p);
+	if (p->p_state == PRS_ZOMBIE) {
+		/*
+		 * If the process is already dead and just awaiting reaping,
+		 * do that now.  This will release the process's reference to
+		 * the process descriptor when it calls back into
+		 * procdesc_reap().
+		 */
+		PROC_SLOCK(p);
+		proc_reap(curthread, p, NULL, 0, NULL);
+	} else {
+		/*
+		 * If the process is not yet dead, we need to kill it, but we
+		 * can't wait around synchronously for it to go away, as that
+		 * path leads to madness (and deadlocks).  First, detach the
+		 * process from its descriptor so that its exit status will
+		 * be reported normally.
+		 */
+		pd->pd_proc = NULL;
+		p->p_procdesc = NULL;
+		procdesc_free(pd);
+
+		/*
+		 * Next, reparent it to init(8) so that there's someone to
+		 * pick up the pieces; finally, terminate with prejudice.
+		 */
+		p->p_sigparent = SIGCHLD;
+		proc_reparent(p, initproc);
+		psignal(p, SIGKILL);
+		PROC_UNLOCK(p);
+		sx_xunlock(&proctree_lock);
+	}
+
+	/*
+	 * Release the file descriptor's reference on the process descriptor.
+	 */
+	procdesc_free(pd);
+	return (0);
+}
+
+static int
+procdesc_read(struct file *fp, struct uio *uio, struct ucred *active_cred,
+    int flags, struct thread *td)
+{
+
+	return (EOPNOTSUPP);
+}
+
+static int
+procdesc_write(struct file *fp, struct uio *uio, struct ucred *active_cred,
+    int flags, struct thread *td)
+{
+
+	return (EOPNOTSUPP);
+}
+
+static int
+procdesc_truncate(struct file *fp, off_t length, struct ucred *active_cred,
+    struct thread *td)
+{
+
+	return (EOPNOTSUPP);
+}
+
+static int
+procdesc_ioctl(struct file *fp, u_long com, void *data,
+    struct ucred *active_cred, struct thread *td)
+{
+
+	return (EOPNOTSUPP);
+}
+
+static int
+procdesc_poll(struct file *fp, int events, struct ucred *active_cred,
+    struct thread *td)
+{
+	struct procdesc *pd;
+	int revents;
+
+	revents = 0;
+	pd = fp->f_data;
+	PROCDESC_LOCK(pd);
+	if (pd->pd_flags & PD_EXITED)
+		revents |= POLLHUP;
+	if (revents == 0) {
+		selrecord(td, &pd->pd_selinfo);
+		pd->pd_flags |= PD_SELECTED;
+	}
+	PROCDESC_UNLOCK(pd);
+	return (revents);
+}
+
+static int
+procdesc_kqfilter(struct file *fp, struct knote *kn)
+{
+
+	return (EOPNOTSUPP);
+}
+
+static int
+procdesc_stat(struct file *fp, struct stat *sb, struct ucred *active_cred,
+    struct thread *td)
+{
+	struct procdesc *pd;
+
+	/*
+	 * XXXRW: Perhaps we should cache some more information from the
+	 * process so that we can return it reliably here even after it has
+	 * died.  For example, caching its credential data.
+	 */
+	bzero(sb, sizeof(*sb));
+	pd = fp->f_data;
+	sx_slock(&proctree_lock);
+	if (pd->pd_proc != NULL) {
+		PROC_LOCK(pd->pd_proc);
+		if (pd->pd_proc->p_state != PRS_ZOMBIE)
+			sb->st_mode = S_IFREG | S_IRWXU;
+		else
+			sb->st_mode = S_IFREG;
+		sb->st_uid = pd->pd_proc->p_ucred->cr_ruid;
+		sb->st_gid = pd->pd_proc->p_ucred->cr_rgid;
+		PROC_UNLOCK(pd->pd_proc);
+	} else
+		sb->st_mode = S_IFREG;
+	sx_sunlock(&proctree_lock);
+	return (0);
+}
+
+#else /* !PROCDESC */
+
+int
+pdgetpid(struct thread *td, struct pdgetpid_args *uap)
+{
+
+	return (ENOSYS);
+}
+
+#endif /* PROCDESC */

Index: sys/kern/syscalls.master
===================================================================
--- sys/kern/syscalls.master	(.../stable/8)	(revision 201781)
+++ sys/kern/syscalls.master	(.../projects/capabilities8)	(revision 205872)
@@ -911,14 +911,25 @@
 512	AUE_SHMCTL	NOSTD	{ int shmctl(int shmid, int cmd, \
 				    struct shmid_ds *buf); }
 513	AUE_LPATHCONF	STD	{ int lpathconf(char *path, int name); }
-514	AUE_CAP_NEW	UNIMPL	cap_new
-515	AUE_CAP_GETRIGHTS	UNIMPL	cap_getrights
-516	AUE_CAP_ENTER	UNIMPL	cap_enter
-517	AUE_CAP_GETMODE	UNIMPL	cap_getmode
-518	AUE_PDFORK	UNIMPL	pdfork
-519	AUE_PDKILL	UNIMPL	pdkill
-520	AUE_PDGETPID	UNIMPL	pdgetpid
-521	AUE_PDWAIT	UNIMPL	pdwait
+
+;
+; Capability system calls.
+;
+514	AUE_CAP_NEW	STD	{ int cap_new(int fd, u_int64_t rights); }
+515	AUE_CAP_GETRIGHTS	STD	{ int cap_getrights(int fd, \
+				    u_int64_t *rightsp); }
+516	AUE_CAP_ENTER	STD	{ int cap_enter(void); }
+517	AUE_CAP_GETMODE	STD	{ int cap_getmode(u_int *modep); }
+
+;
+; Process descriptor system calls.  These need audit event identifiers.
+;
+518	AUE_NULL	STD	{ int pdfork(int *fdp); }
+519	AUE_NULL	STD	{ int pdkill(int fd, int signum); }
+520	AUE_NULL	STD	{ int pdgetpid(int fd, pid_t *pidp); }
+521	AUE_NULL	STD	{ int pdwait(int fd, int *status, \
+				    int options, struct rusage *rusage); }
+
 522	AUE_SELECT	STD	{ int pselect(int nd, fd_set *in, \
 				    fd_set *ou, fd_set *ex, \
 				    const struct timespec *ts, \
Index: sys/kern/systrace_args.c
===================================================================
--- sys/kern/systrace_args.c	(.../stable/8)	(revision 201781)
+++ sys/kern/systrace_args.c	(.../projects/capabilities8)	(revision 205872)
@@ -3072,6 +3072,67 @@
 		*n_args = 2;
 		break;
 	}
+	/* cap_new */
+	case 514: {
+		struct cap_new_args *p = params;
+		iarg[0] = p->fd; /* int */
+		uarg[1] = p->rights; /* u_int64_t */
+		*n_args = 2;
+		break;
+	}
+	/* cap_getrights */
+	case 515: {
+		struct cap_getrights_args *p = params;
+		iarg[0] = p->fd; /* int */
+		uarg[1] = (intptr_t) p->rightsp; /* u_int64_t * */
+		*n_args = 2;
+		break;
+	}
+	/* cap_enter */
+	case 516: {
+		*n_args = 0;
+		break;
+	}
+	/* cap_getmode */
+	case 517: {
+		struct cap_getmode_args *p = params;
+		uarg[0] = (intptr_t) p->modep; /* u_int * */
+		*n_args = 1;
+		break;
+	}
+	/* pdfork */
+	case 518: {
+		struct pdfork_args *p = params;
+		uarg[0] = (intptr_t) p->fdp; /* int * */
+		*n_args = 1;
+		break;
+	}
+	/* pdkill */
+	case 519: {
+		struct pdkill_args *p = params;
+		iarg[0] = p->fd; /* int */
+		iarg[1] = p->signum; /* int */
+		*n_args = 2;
+		break;
+	}
+	/* pdgetpid */
+	case 520: {
+		struct pdgetpid_args *p = params;
+		iarg[0] = p->fd; /* int */
+		uarg[1] = (intptr_t) p->pidp; /* pid_t * */
+		*n_args = 2;
+		break;
+	}
+	/* pdwait */
+	case 521: {
+		struct pdwait_args *p = params;
+		iarg[0] = p->fd; /* int */
+		uarg[1] = (intptr_t) p->status; /* int * */
+		iarg[2] = p->options; /* int */
+		uarg[3] = (intptr_t) p->rusage; /* struct rusage * */
+		*n_args = 4;
+		break;
+	}
 	/* pselect */
 	case 522: {
 		struct pselect_args *p = params;
@@ -8166,6 +8227,100 @@
 			break;
 		};
 		break;
+	/* cap_new */
+	case 514:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "u_int64_t";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cap_getrights */
+	case 515:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "u_int64_t *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cap_enter */
+	case 516:
+		break;
+	/* cap_getmode */
+	case 517:
+		switch(ndx) {
+		case 0:
+			p = "u_int *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* pdfork */
+	case 518:
+		switch(ndx) {
+		case 0:
+			p = "int *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* pdkill */
+	case 519:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* pdgetpid */
+	case 520:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "pid_t *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* pdwait */
+	case 521:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "int *";
+			break;
+		case 2:
+			p = "int";
+			break;
+		case 3:
+			p = "struct rusage *";
+			break;
+		default:
+			break;
+		};
+		break;
 	/* pselect */
 	case 522:
 		switch(ndx) {
Index: sys/kern/kern_mib.c
===================================================================
--- sys/kern/kern_mib.c	(.../stable/8)	(revision 201781)
+++ sys/kern/kern_mib.c	(.../projects/capabilities8)	(revision 205872)
@@ -57,7 +57,7 @@
 
 SYSCTL_NODE(, 0,	  sysctl, CTLFLAG_RW, 0,
 	"Sysctl internal magic");
-SYSCTL_NODE(, CTL_KERN,	  kern,   CTLFLAG_RW, 0,
+SYSCTL_NODE(, CTL_KERN,	  kern,   CTLFLAG_RW|CTLFLAG_CAPRD, 0,
 	"High kernel, proc, limits &c");
 SYSCTL_NODE(, CTL_VM,	  vm,     CTLFLAG_RW, 0,
 	"Virtual memory");
@@ -90,23 +90,24 @@
 SYSCTL_STRING(_kern, OID_AUTO, ident, CTLFLAG_RD|CTLFLAG_MPSAFE,
     kern_ident, 0, "Kernel identifier");
 
-SYSCTL_STRING(_kern, KERN_OSRELEASE, osrelease, CTLFLAG_RD|CTLFLAG_MPSAFE,
-    osrelease, 0, "Operating system release");
+SYSCTL_STRING(_kern, KERN_OSRELEASE, osrelease, CTLFLAG_RD|CTLFLAG_MPSAFE|
+    CTLFLAG_CAPRD, osrelease, 0, "Operating system release");
 
-SYSCTL_INT(_kern, KERN_OSREV, osrevision, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_OSREV, osrevision, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, BSD, "Operating system revision");
 
 SYSCTL_STRING(_kern, KERN_VERSION, version, CTLFLAG_RD|CTLFLAG_MPSAFE,
     version, 0, "Kernel version");
 
-SYSCTL_STRING(_kern, KERN_OSTYPE, ostype, CTLFLAG_RD|CTLFLAG_MPSAFE,
+SYSCTL_STRING(_kern, KERN_OSTYPE, ostype, CTLFLAG_RD|CTLFLAG_MPSAFE|
+    CTLFLAG_CAPRD,
     ostype, 0, "Operating system type");
 
 /*
  * NOTICE: The *userland* release date is available in
  * /usr/include/osreldate.h
  */
-SYSCTL_INT(_kern, KERN_OSRELDATE, osreldate, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_OSRELDATE, osreldate, CTLFLAG_RD | CTLFLAG_CAPRD,
     &osreldate, 0, "Kernel release date");
 
 SYSCTL_INT(_kern, KERN_MAXPROC, maxproc, CTLFLAG_RDTUN,
@@ -118,23 +119,23 @@
 SYSCTL_INT(_kern, OID_AUTO, maxusers, CTLFLAG_RDTUN,
     &maxusers, 0, "Hint for kernel tuning");
 
-SYSCTL_INT(_kern, KERN_ARGMAX, argmax, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_ARGMAX, argmax, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, ARG_MAX, "Maximum bytes of argument to execve(2)");
 
-SYSCTL_INT(_kern, KERN_POSIX1, posix1version, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_POSIX1, posix1version, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, _POSIX_VERSION, "Version of POSIX attempting to comply to");
 
-SYSCTL_INT(_kern, KERN_NGROUPS, ngroups, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_NGROUPS, ngroups, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, NGROUPS_MAX, "Maximum number of groups a user can belong to");
 
-SYSCTL_INT(_kern, KERN_JOB_CONTROL, job_control, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_JOB_CONTROL, job_control, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, 1, "Whether job control is available");
 
 #ifdef _POSIX_SAVED_IDS
-SYSCTL_INT(_kern, KERN_SAVED_IDS, saved_ids, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_SAVED_IDS, saved_ids, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, 1, "Whether saved set-group/user ID is available");
 #else
-SYSCTL_INT(_kern, KERN_SAVED_IDS, saved_ids, CTLFLAG_RD,
+SYSCTL_INT(_kern, KERN_SAVED_IDS, saved_ids, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, 0, "Whether saved set-group/user ID is available");
 #endif
 
@@ -143,13 +144,13 @@
 SYSCTL_STRING(_kern, KERN_BOOTFILE, bootfile, CTLFLAG_RW,
     kernelname, sizeof kernelname, "Name of kernel file booted");
 
-SYSCTL_INT(_hw, HW_NCPU, ncpu, CTLFLAG_RD,
+SYSCTL_INT(_hw, HW_NCPU, ncpu, CTLFLAG_RD | CTLFLAG_CAPRD,
     &mp_ncpus, 0, "Number of active CPUs");
 
-SYSCTL_INT(_hw, HW_BYTEORDER, byteorder, CTLFLAG_RD,
+SYSCTL_INT(_hw, HW_BYTEORDER, byteorder, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, BYTE_ORDER, "System byte order");
 
-SYSCTL_INT(_hw, HW_PAGESIZE, pagesize, CTLFLAG_RD,
+SYSCTL_INT(_hw, HW_PAGESIZE, pagesize, CTLFLAG_RD | CTLFLAG_CAPRD,
     0, PAGE_SIZE, "System memory page size");
 
 static int
@@ -166,7 +167,7 @@
 }
 
 SYSCTL_PROC(_kern, KERN_ARND, arandom,
-    CTLTYPE_OPAQUE | CTLFLAG_RD | CTLFLAG_MPSAFE, NULL, 0,
+    CTLTYPE_OPAQUE | CTLFLAG_RD | CTLFLAG_MPSAFE | CTLFLAG_CAPRD, NULL, 0,
     sysctl_kern_arnd, "", "arc4rand");
 
 static int
@@ -425,6 +426,8 @@
  * This is really cheating.  These actually live in the libc, something
  * which I'm not quite sure is a good idea anyway, but in order for
  * getnext and friends to actually work, we define dummies here.
+ *
+ * XXXRW: These probably should be CTLFLAG_CAPRD.
  */
 SYSCTL_STRING(_user, USER_CS_PATH, cs_path, CTLFLAG_RD,
     "", 0, "PATH that finds all the standard utilities");
Index: sys/fs/nfsclient/nfs_clport.c
===================================================================
--- sys/fs/nfsclient/nfs_clport.c	(.../stable/8)	(revision 201781)
+++ sys/fs/nfsclient/nfs_clport.c	(.../projects/capabilities8)	(revision 205872)
@@ -1182,7 +1182,8 @@
 		error = copyin(uap->argp, (caddr_t)&nfscbdarg, sizeof(nfscbdarg));
 		if (error)
 			return (error);
-		if ((error = fget(td, nfscbdarg.sock, &fp)) != 0) {
+		if ((error = fget(td, nfscbdarg.sock, CAP_SOCK_ALL, &fp))
+		    != 0) {
 			return (error);
 		}
 		if (fp->f_type != DTYPE_SOCKET) {
Index: sys/fs/nfs/nfsport.h
===================================================================
--- sys/fs/nfs/nfsport.h	(.../stable/8)	(revision 201781)
+++ sys/fs/nfs/nfsport.h	(.../projects/capabilities8)	(revision 205872)
@@ -42,6 +42,7 @@
 #ifdef _KERNEL
 #include <sys/unistd.h>
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/systm.h>
 #include <sys/conf.h>
 #include <sys/dirent.h>
Index: sys/fs/portalfs/portal_vfsops.c
===================================================================
--- sys/fs/portalfs/portal_vfsops.c	(.../stable/8)	(revision 201781)
+++ sys/fs/portalfs/portal_vfsops.c	(.../projects/capabilities8)	(revision 205872)
@@ -40,6 +40,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/domain.h>
 #include <sys/filedesc.h>
 #include <sys/kernel.h>
@@ -112,7 +113,10 @@
 	if (error)
 		return (error);
 
-	if ((error = fget(td, v, &fp)) != 0)
+	/*
+	 * XXXRW: I suppose we want CAP_SOCK_ALL here?
+	 */
+	if ((error = fget(td, v, CAP_READ | CAP_WRITE, &fp)) != 0)
 		return (error);
         if (fp->f_type != DTYPE_SOCKET) {
 		fdrop(fp, td);
Index: sys/fs/portalfs/portal_vnops.c
===================================================================
--- sys/fs/portalfs/portal_vnops.c	(.../stable/8)	(revision 201781)
+++ sys/fs/portalfs/portal_vnops.c	(.../projects/capabilities8)	(revision 205872)
@@ -407,8 +407,12 @@
 	/*
 	 * Check that the mode the file is being opened for is a subset
 	 * of the mode of the existing descriptor.
+	 *
+	 * XXXRW: It is stunningly non-obvious how to handle this with
+	 * respect to capabilities.  Does that mean this is simply a bad
+	 * idea?
 	 */
-	if ((error = fget(td, fd, &fp)) != 0)
+	if ((error = fget(td, fd, 0, &fp)) != 0)
 		goto bad;
 	if (((ap->a_mode & (FREAD|FWRITE)) | fp->f_flag) != fp->f_flag) {
 		fdrop(fp, td);
Index: sys/fs/nfsserver/nfs_nfsdport.c
===================================================================
--- sys/fs/nfsserver/nfs_nfsdport.c	(.../stable/8)	(revision 201781)
+++ sys/fs/nfsserver/nfs_nfsdport.c	(.../projects/capabilities8)	(revision 205872)
@@ -2930,7 +2930,8 @@
 		error = copyin(uap->argp, (caddr_t)&sockarg, sizeof (sockarg));
 		if (error)
 			return (error);
-		if ((error = fget(td, sockarg.sock, &fp)) != 0) {
+		if ((error = fget(td, sockarg.sock, CAP_SOCK_ALL, &fp))
+		    != 0) {
 			return (error);
 		}
 		if (fp->f_type != DTYPE_SOCKET) {
Index: sys/fs/fdescfs/fdesc_vnops.c
===================================================================
--- sys/fs/fdescfs/fdesc_vnops.c	(.../stable/8)	(revision 201781)
+++ sys/fs/fdescfs/fdesc_vnops.c	(.../projects/capabilities8)	(revision 205872)
@@ -40,6 +40,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/dirent.h>
 #include <sys/filedesc.h>
@@ -305,7 +306,10 @@
 		fd = fd1;
 	}
 
-	if ((error = fget(td, fd, &fp)) != 0)
+	/*
+	 * XXXRW: 'fp' isn't actually used so no rights to check?
+	 */
+	if ((error = fget(td, fd, 0, &fp)) != 0)
 		goto bad;
 
 	/* Check if we're looking up ourselves. */
@@ -387,6 +391,7 @@
 		struct ucred *a_cred;
 	} */ *ap;
 {
+
 	struct vnode *vp = ap->a_vp;
 	struct vattr *vap = ap->a_vap;
 
@@ -436,6 +441,7 @@
 		struct ucred *a_cred;
 	} */ *ap;
 {
+#if 0
 	struct vattr *vap = ap->a_vap;
 	struct vnode *vp;
 	struct mount *mp;
@@ -479,6 +485,9 @@
 	}
 	fdrop(fp, td);
 	return (error);
+#else
+	return (EOPNOTSUPP);
+#endif
 }
 
 #define UIO_MX 16
Index: sys/netgraph/ng_socket.c
===================================================================
--- sys/netgraph/ng_socket.c	(.../stable/8)	(revision 201781)
+++ sys/netgraph/ng_socket.c	(.../projects/capabilities8)	(revision 205872)
@@ -678,9 +678,12 @@
 	}
 
 	/* Check that the FD given is legit. and change it to a pointer to a
-	 * struct file. */
+	 * struct file.
+	 *
+	 * XXXRW: For now, no capability right required to pass an fd.
+	 */
 	fd = CMSG_DATA(cm);
-	if ((error = fget(td, fd, &fp)) != 0)
+	if ((error = fget(td, fd, 0, &fp)) != 0)
 		return (error);
 
 	/* Depending on what kind of resource it is, act differently. For
Index: sys/nfsserver/nfs_srvkrpc.c
===================================================================
--- sys/nfsserver/nfs_srvkrpc.c	(.../stable/8)	(revision 201781)
+++ sys/nfsserver/nfs_srvkrpc.c	(.../projects/capabilities8)	(revision 205872)
@@ -39,6 +39,7 @@
 #include "opt_kgssapi.h"
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/systm.h>
 #include <sys/sysproto.h>
 #include <sys/kernel.h>
@@ -179,7 +180,8 @@
 		    sizeof(addsockarg));
 		if (error)
 			return (error);
-		if ((error = fget(td, addsockarg.sock, &fp)) != 0)
+		if ((error = fget(td, addsockarg.sock, CAP_SOCK_ALL, &fp))
+		    != 0)
 			return (error);
 		if (fp->f_type != DTYPE_SOCKET) {
 			fdrop(fp, td);
Index: sys/dev/amr/amr_linux.c
===================================================================
--- sys/dev/amr/amr_linux.c	(.../stable/8)	(revision 201781)
+++ sys/dev/amr/amr_linux.c	(.../projects/capabilities8)	(revision 205872)
@@ -30,6 +30,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/kernel.h>
 #include <sys/module.h>
@@ -74,7 +75,7 @@
 	struct file *fp;
 	int error;
 
-	if ((error = fget(p, args->fd, &fp)) != 0)
+	if ((error = fget(p, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	error = fo_ioctl(fp, args->cmd, (caddr_t)args->arg, p->td_ucred, p);
 	fdrop(fp, p);
Index: sys/dev/mfi/mfi_linux.c
===================================================================
--- sys/dev/mfi/mfi_linux.c	(.../stable/8)	(revision 201781)
+++ sys/dev/mfi/mfi_linux.c	(.../projects/capabilities8)	(revision 205872)
@@ -29,6 +29,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/kernel.h>
 #include <sys/module.h>
@@ -95,7 +96,7 @@
 		break;
 	}
 
-	if ((error = fget(p, args->fd, &fp)) != 0)
+	if ((error = fget(p, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	error = fo_ioctl(fp, cmd, (caddr_t)args->arg, p->td_ucred, p);
 	fdrop(fp, p);
Index: sys/dev/hwpmc/hwpmc_logging.c
===================================================================
--- sys/dev/hwpmc/hwpmc_logging.c	(.../stable/8)	(revision 201781)
+++ sys/dev/hwpmc/hwpmc_logging.c	(.../projects/capabilities8)	(revision 205872)
@@ -37,6 +37,7 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/file.h>
 #include <sys/kernel.h>
 #include <sys/kthread.h>
@@ -584,7 +585,7 @@
 		po->po_file));
 
 	/* get a reference to the file state */
-	error = fget_write(curthread, logfd, &po->po_file);
+	error = fget_write(curthread, logfd, CAP_WRITE, &po->po_file);
 	if (error)
 		goto error;
 
Index: sys/dev/aac/aac_linux.c
===================================================================
--- sys/dev/aac/aac_linux.c	(.../stable/8)	(revision 201781)
+++ sys/dev/aac/aac_linux.c	(.../projects/capabilities8)	(revision 205872)
@@ -33,6 +33,7 @@
 
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/kernel.h>
 #include <sys/module.h>
@@ -78,7 +79,7 @@
 	u_long cmd;
 	int error;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	cmd = args->cmd;
 
Index: sys/dev/ipmi/ipmi_linux.c
===================================================================
--- sys/dev/ipmi/ipmi_linux.c	(.../stable/8)	(revision 201781)
+++ sys/dev/ipmi/ipmi_linux.c	(.../projects/capabilities8)	(revision 205872)
@@ -32,6 +32,7 @@
  */
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/systm.h>
 #include <sys/conf.h>
 #include <sys/kernel.h>
@@ -92,7 +93,7 @@
 	u_long cmd;
 	int error;
 
-	if ((error = fget(td, args->fd, &fp)) != 0)
+	if ((error = fget(td, args->fd, CAP_IOCTL, &fp)) != 0)
 		return (error);
 	cmd = args->cmd;
 
Index: sys/dev/snp/snp.c
===================================================================
--- sys/dev/snp/snp.c	(.../stable/8)	(revision 201781)
+++ sys/dev/snp/snp.c	(.../projects/capabilities8)	(revision 205872)
@@ -28,6 +28,7 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/conf.h>
 #include <sys/fcntl.h>
 #include <sys/filio.h>
@@ -257,6 +258,9 @@
 			SNP_UNLOCK();
 			return (EBUSY);
 		}
+		/*
+		 * XXXRW: no capability check here.
+		 */
 		error = ttyhook_register(&ss->snp_tty, td->td_proc,
 		    *(int *)data, &snp_hook, ss);
 		SNP_UNLOCK();
